.MODEL SMALL
.STACK 100h
.DATA
        Nomb_Fich DB 'FICH.ASM',0
        Hand_Fich DW ?
        Buffer DB 1024 DUP(?)
.CODE
Codigo PROC
        mov dx, @DATA           ; Obtenemos la direccion de comienzo del
        mov ds,dx               ; segmento de datos e inicializamos ds

        mov ax,3D00h             ; Abrir el fichero 
        mov dx, OFFSET Nomb_Fich ; Nombre del fichero
        int 21h
        jc @Error
        mov Hand_Fich, ax        ; Colocamos el Handler en una variable
        mov cx,10
@@Bucle:
        push cx
        mov ax,3F00h            ; Leemos los 100 primeros bytes del fichero
        mov bx,Hand_Fich
        mov cx,1023
        mov dx,OFFSET Buffer
        int 21h
        pop cx
        jc @Error

        mov [Buffer + 1024],'$'  ; Ponemos un signo $ al final del texto leido

        mov ah,02h              ; Poner en la posicion 0,0
        mov bh,0
        xor dx,dx
        int 10h

        mov ax,0900h            ; Imprimimos la cadena
        mov dx, OFFSET Buffer   ; La direccion de la cadena a leer
        int 21h
        loopnz @@Bucle
        jmp @NoError

  
@Error:
        mov bl,30h
        mov dl,al
        add dl, bl
        mov ah, 02h
        int 21h
@NoError:
        mov ah,4Ch
        int 21h
Codigo ENDP
        END codigo

