;DOSSEG
.MODEL SMALL,PASCAL
.STACK 500h 
.DATA
        Ventana1 EQU 0A000h
        NombreTGA      DB  'LENS.TGA',0
;        HandleTGA      dw  ?
        BufferTGA          DB 1024 DUP(?)
;

.CODE
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para activar el modo de video 320 x 200 x 256
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Modo13 MACRO
        mov ax,0013h    ; Modo de video 
        int 10h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para desactivar el modo 13h y salir al sistema
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Salir MACRO
        mov ax,0003h    ; Modo texto
        int 10h
        mov ax,4C00h    ; Funcion 4Ch: Salir al sistema
        int 21h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;#####################################

;#####################################

CargaTGA PROC USES ax bx cx dx ds es di si, Nombre_TGA:PTR BYTE, \
Buffer:PTR BYTE

LOCAL Handle_TGA:WORD

;        mov ax, @DATA           ; Situamos ds al valor del segmento de datos
;        mov ds, ax

;        Modo13                  ; Activamos el modo grafico

        mov ax,3D00h            ; Funcion 3Dh: Abrir un fichero modo lectura
        mov dx,offset Nombre_TGA        ; Direccion de comienzo del nombre
        int 21h
;        jnc @@Sigue             ; Sino hay error seguir
;        @@Salir

;@@Sigue:
        mov Handle_TGA,ax       ; Al abrir el fichero se devuelve en ax el 
                                ; handle del fichero

        mov ah,3Fh              ; Funcion 3Fh: Leer los CX elementos del 
        mov bx,Handle_TGA       ; fichero y escribirlos en R
        mov cx,18
        mov dx,offset Buffer    ; Leemos la cabecera del fichero
        int 21h
;        jnc @@Sigue2            ; Sino hay error seguir
;        @@Salir

;@@Sigue2:
        mov ah,3Fh              ; Funcion 3Fh: Leer los CX elementos del
        mov bx,Handle_TGA       ; fichero y escribirlos en R
        mov cx,768
        mov dx,offset Buffer    ; Leemos la paleta de colores
        int 21h
;        jc @@Salir               ; Si hay error ir a salir

        mov cx,256              ; Elementos de la paleta

        mov ax,@DATA            ; Preparamos los registros de segmentos                       
        mov es,ax               ; y los de desplazamiento de cadena fuente
        mov si,offset Buffer    ; y destino para emplear las instruciones 
        mov di,offset Buffer    ; lods_ y stos_ que son las mas comodas
        cld                     ; Borra el flag de direccion

@@ModifPal:
        lodsb                   ; al <- DS:SI y INC si
        shr al,1                ; dividimos el valor entre cuatro 
        shr al,1                ; tenemos la nueva componente AZUL
        mov ah,al               ; situamos el nuevo valor en AH
        lodsb                   ; al <- DS:SI y INC si
        shr al,1                ; dividimos el valor entre cuatro
        shr al,1                ; tenemos la nueva componente VERDE
        mov bh,al               ; situamos el nuevo valor en BH
        lodsb                   ; al <- DS:SI y INC si
        shr al,1                ; dividimos el valor entre cuatro
        shr al,1                ; tenemos la nueva componente ROJA
        stosb                   ; ES:DI <- al y INC di , almacenamos el ROJO
        mov al,bh               ; 
        stosb                   ; ES:DI <- al y INC di , almacenamos el VERDE
        mov al,ah       
        stosb                   ; ES:DI <- al y INC di , almacenamos el AZUL
        dec cx                  ; un color menos de la Paleta
        jnz @@ModifPal          ; repetir hasta cero

        mov ax,1012h            ; Funcion 10h subfuncion 12h establecer la
        mov bx,0                ; paleta de colores situada en ES:DX
        mov cx,256              ; numero de colores
        mov dx,offset Buffer
        int 10h

        mov ah,3Fh              ; Leer del fichero toda la imagen que esta
        mov bx,Handle_TGA       ; sin comprimir y situarla en la Ventana1
        mov cx,64000            ; tamao de la imagen
        mov dx, Ventana1
        mov ds,dx
        mov dx,0
        int 21h
;        jc @@Quit               ; si falla salir

        mov ah,3Eh              ; Funcion 3Eh: Cerrar un fichero 
        mov bx,Handle_TGA
        int 21h
        ret
CargaTGA ENDP;
Codigo PROC
          mov ax,@DATA
          mov ds,ax
          Modo13
          mov ax,OFFSET NombreTGA
          push ax
          mov ax,OFFSET BufferTGA
          push ax
          call CargaTGA
@@bucle:
          mov ah, 06h
          mov dl, 0FFh
          int 21h
          jz @@bucle

          Salir
Codigo ENDP
        END     Codigo
