.MODEL COMPACT, PASCAL
.STACK 500h 
.FARDATA Datos
S_Punto STRUC
        Coor_X DB ?
        Coor_Y DB ?
        Coor_Z DB ?
S_Punto ENDS

        R_circulo DB 43
        Dist_plano DB 50
        R_esfera DB ?

        Ped_Radio DB ' Introduzca el radio : $'
        Ped_Dist  DB ' Introduzca la distancia al plano: $'

        Pto_Q S_Punto <0,0,0>
        Pto_P S_Punto <0,0,0>
        Pto_I S_Punto <0,0,0>

        Pos_MX DW 0
        Pos_MY DW 0

        Distancia DW ?

        Ventana1        EQU 0A000h
        NombreTGA       DB  'LENTE.TGA',0
        HandleTGA       DW  ?

        Desp_Mat_T      DW 0
        Ancho_Img       DW 90
        Ancho_Pant      DW 320
        Alto_Pant       DB 200
        Area            DW 8100
        Buffer_Fuente   DB 8100 DUP(?)
        Buffer_Destino  DB 8100 DUP(?)
        MatrizTrans     DW 8100 DUP(0)
        BufferTGA       DB 1024 DUP(?)

.FARDATA Imagen
        ImagenBak       DB 64000 DUP(?)
;
.CODE
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para activar el segmento de datos
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Seg_Datos MACRO
        push dx
        mov dx,SEG datos
        mov ds,dx
        pop dx
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para activar el modo de video 320 x 200 x 256
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Modo13 MACRO
        mov ax,0013h    ; Modo de video 
        int 10h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para desactivar el modo 13h y salir al sistema
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Salir MACRO
        mov ax,0003h    ; Modo texto
        int 10h
        mov ax,4C00h    ; Funcion 4Ch: Salir al sistema
        int 21h
ENDM
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;#####################################
; Este procedimiento carga una images
; en formato TGA 256 colores 
;#####################################

CargaTGA PROC NEAR USES ax bx cx dx ds es di si, Nombre_TGA:WORD,Buffer:WORD

LOCAL Handle_TGA:WORD
        mov ax,3D00h            ; Funcion 3Dh: Abrir un fichero modo lectura
        mov dx,Nombre_TGA        ; Direccion de comienzo del nombre
        int 21h

        mov Handle_TGA, ax      ; Al abrir el fichero se devuelve en ax el
                                ; handle del fichero

        mov ah, 3Fh             ; Funcion 3Fh: Leer los CX elementos del 
        mov bx, Handle_TGA      ; fichero y escribirlos en R
        mov cx, 18
        mov dx, Buffer   ; Leemos la cabecera del fichero
        int 21h

        mov ah, 3Fh             ; Funcion 3Fh: Leer los CX elementos del
        mov bx, Handle_TGA      ; fichero y escribirlos en R
        mov cx, 768
        mov dx, Buffer   ; Leemos la paleta de colores
        int 21h

        mov cx, 256             ; Elementos de la paleta

        mov ax, @DATA           ; Preparamos los registros de segmentos                       
        mov es, ax              ; y los de desplazamiento de cadena fuente
        mov si, Buffer   ; y destino para emplear las instruciones 
        mov di, Buffer   ; lods_ y stos_ que son las mas comodas
        cld                     ; Borra el flag de direccion

@@ModifPal:
        lodsb                   ; al <- DS:SI y INC si
        shr al, 1               ; dividimos el valor entre cuatro 
        shr al, 1               ; tenemos la nueva componente AZUL
        mov ah, al              ; situamos el nuevo valor en AH
        lodsb                   ; al <- DS:SI y INC si
        shr al, 1               ; dividimos el valor entre cuatro
        shr al, 1               ; tenemos la nueva componente VERDE
        mov bh, al              ; situamos el nuevo valor en BH
        lodsb                   ; al <- DS:SI y INC si
        shr al, 1               ; dividimos el valor entre cuatro
        shr al, 1               ; tenemos la nueva componente ROJA
        stosb                   ; ES:DI <- al y INC di , almacenamos el ROJO
        mov al, bh              ; 
        stosb                   ; ES:DI <- al y INC di , almacenamos el VERDE
        mov al, ah       
        stosb                   ; ES:DI <- al y INC di , almacenamos el AZUL
        dec cx                  ; un color menos de la Paleta
        jnz @@ModifPal          ; repetir hasta cero

        mov ax, 1012h           ; Funcion 10h subfuncion 12h establecer la
        mov bx, 0               ; paleta de colores situada en ES:DX
        mov cx, 256             ; numero de colores
        mov dx, Buffer
        int 10h 

        mov ah, 3Fh             ; Leer del fichero toda la imagen que esta
        mov bx, Handle_TGA      ; sin comprimir y situarla en la Ventana1
        mov cx, 64000           ; tamao de la imagen
        mov dx, Ventana1
        mov ds, dx
        mov dx, 0
        int 21h

        mov ah, 3Eh             ; Funcion 3Eh: Cerrar un fichero 
        mov bx, Handle_TGA
        int 21h
        ret
CargaTGA ENDP


;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro que devuelve en AX el cuadrado del valor
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Cuadrado MACRO Valor
        xor ax,ax
        mov al,Valor
        imul al
ENDM
;###############################################
; Raiz devuelve en AX el valor de la raiz entera
;###############################################
Raiz PROC NEAR USES cx bx , Operando:WORD 
        mov bx, Operando
        jns @Continua
        neg bx
@Continua:
        xor cx,cx
@bucle:
        inc cl
        Cuadrado cl
        cmp ax,bx
        jle @bucle
        dec cl
        xor ax,ax
        mov al,cl
        ret
Raiz ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Procedimiento que calcula el valor de la variable Distancia
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Dist PROC NEAR USES ax bx 
        xor ax,ax
        xor bx,bx
        Cuadrado ds:Dist_plano     ; Obtenemos d^2
        push ax
        Cuadrado ds:Pto_P.Coor_X   ; Obtenemos Px^2
        push ax
        Cuadrado ds:Pto_P.Coor_Y   ; Obtenemos Py^2
        pop bx
        add ax,bx               ; Calculamos Px^2 + Py^2
        push ax
        Cuadrado ds:R_circulo      ; Obtenemos Rc^2
        pop bx
        sub bx,ax               ; Calculamos (Px^2 + Py^2) - Rc^2
        pop ax
        sub ax,bx               ; Calculamos d^2 -((Px^2 + Py^2) -Rc^2)
        mov ds:Distancia, ax       ; Asignamos el valor a Distancia
        ret
Calc_Dist ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para calcular Pto_Q.Coor_Z 
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Qz PROC NEAR USES ax 
        xor ax,ax
        push ds:Distancia
        call Raiz               ; Calculamos SQRT(D)
        add al,1                ; Calculamos 1+SQRT(D)
        mov ds:Pto_Q.Coor_Z, al    ; Asignamos el valor a la variable
        ret
Calc_Qz ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para calcular Pto_I.Coor_X
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Ix PROC NEAR USES ax bx
        xor ax,ax
        mov al, ds:Pto_Q.Coor_Z
        add al, ds:Dist_Plano      ; Calculamos (Qz + d)
        push ax
        xor ax,ax
        mov al, ds:Dist_Plano      
        imul ds:Pto_P.Coor_X       ; Calculamos (d * Px)
        pop bx
        idiv bl                  ; Calculamos (d*Px) / (Qz +d)
        mov ds:Pto_I.Coor_X, al    ; Asignamos el valor a la variable
        ret
Calc_Ix ENDP
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
; Macro para calcular Pto_I.Coor_Y
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
Calc_Iy PROC NEAR USES ax bx
        xor ax,ax
        mov al, ds:Pto_Q.Coor_Z
        add al, ds:Dist_Plano      ; Calculamos (Qz + d)
        push ax
        xor ax,ax
        mov al, ds:Dist_Plano      
        imul ds:Pto_P.Coor_Y        ; Calculamos (d * Py)
        pop bx
        idiv bl                  ; Calculamos (d*Py) / (Qz +d)
        mov ds:Pto_I.Coor_Y, al    ; Asignamos el valor a la variable
        ret
Calc_Iy ENDP

;################################################
; Dar_Cateto devuelve en AX el valor del cateto
; opuesto segn el Teorema de Pitagoras
;################################################
Dar_Cateto PROC NEAR USES bx ,Base:BYTE, Cateto: BYTE
        Cuadrado Base
        push ax
        Cuadrado Cateto
        pop bx
        add ax,bx
        push ax
        call Raiz
        ret
Dar_Cateto ENDP

;##################################################
; Transformacion de un punto ,devuelve en AX
;##################################################
Trans_Pto PROC NEAR USES bx cx , Cnt_X :BYTE, Cnt_Y:BYTE, Ancho:BYTE
LOCAL Medio_Ancho: BYTE

        mov al, Ancho
        shr al,1                ; Dividimos por dos el Ancho
        mov Medio_Ancho, al     ; Lo almacenamos en Medio_Ancho
        xor ax,ax
        call Calc_Dist  ; Calculamos el valor de D
        call Calc_Qz    ; Calculamos Qz = 1 + SQRT(D)
        call Calc_Ix    ; Calculamos Ix = (d * Qx )/(d + Qz)
        call Calc_Iy    ; Calculamos Iy = (d * Qy )/(d + Qz)
        mov ds:Pto_I.Coor_Z, 0
        mov al, Medio_Ancho
        add al, ds:Pto_I.Coor_Y
        imul Ancho
        push ax
        mov al, Medio_Ancho
        add al, ds:Pto_I.Coor_X
        pop bx
        cbw
        add ax,bx
        mov ds:Desp_Mat_T,ax
        ret
Trans_Pto ENDP

;##################################################
; Crear_Matriz modifica la matriz de transformacion
;##################################################
Crear_Matriz PROC NEAR USES bx cx dx, Ancho : BYTE
LOCAL Cnt_X: BYTE,Cnt_Y:BYTE, Desp_Pant :WORD, Desp_Mat :WORD, \
Medio_Ancho :BYTE

        mov al, Ancho       
        shr al,1                ; Dividimos por dos el Ancho
        mov Medio_Ancho, al     ; Lo almacenamos en Medio_Ancho
        xor cx,cx
        mov dx,ds
        mov es,dx
        mov di,OFFSET ds:MatrizTrans
@Bucle_for1:                    ; Bucle FOR Cnt_X = 0 TO Ancho para 
                                ; la coordenada X
        mov Cnt_Y,cl
        xor cx,cx
   @Bucle_for2:                 ; Bucle FOR Cnt_Y = 0 TO Ancho -1 para
                                ; la coordenada Y
                mov Cnt_X,cl  
                mov cl,Cnt_Y
                sub cl,Medio_Ancho
                xor bx,bx
                mov bl,Cnt_X
                sub bl,Medio_Ancho
                mov ds:Pto_P.Coor_X, bl    
                mov ds:Pto_P.Coor_Y, cl
                mov ds:Pto_Q.Coor_X, bl
                mov ds:Pto_Q.Coor_Y, cl
                push bx       ; Paso de parametros del procedimiento
                push cx       ; Cateto que devuelve un valor en AX 
                call Dar_Cateto
                xor bx,bx
                xchg bx,ax       ; Cambiamos el valor de sitio
                mov al,Cnt_Y    ; Calculamos el desplazamiento dentro de la
                imul Ancho      ; matriz de transformacion
                push ax
                mov al,Cnt_X    ;\
                cbw             ;/
                pop cx
                add ax,cx       ; Cnt_Y * Medio_Ancho + Cnt_X
                mov Desp_Mat,ax
                cmp ds:R_Circulo, bl        ; El punto esta fuera del circulo de
                jle @Es_Menor            ; corte del plano con la esfera
                                ;; El punto esta en la lupa
                        xor bx,bx
                        mov bl,Cnt_X
                        push bx
                        mov bl,Cnt_Y
                        push bx
                        mov bl,Ancho
                        push bx
                        call Trans_Pto
                        mov ax,ds:Desp_Mat_T
              @Es_Menor:                ; corte del plano con la esfera
                        ;mov bx,Desp_Mat
                        ;shl bx,1
                        stosw

                        ;mov ds:MatrizTrans[bx], ax         ; Asignamos el nuevo
                                                        ; valor
                mov cl,Cnt_X
                inc cl
                cmp cl,Ancho
                jl @Bucle_for2
        mov cl,Cnt_Y
        inc cl
        mov ch,Ancho
        cmp cl, ch 
        jl @Bucle_for1
        ret
Crear_Matriz ENDP

;############################################################################
; Procedimiento que toma un trozo de la imagen y la guarda en un buffer
;############################################################################
CargarBuffer PROC NEAR USES ax cx si di ds es , Pos_X :WORD, Pos_Y:WORD, \
Dest :WORD
LOCAL Ancho_I:WORD, Ancho_P:WORD

        mov ax, ds:Ancho_Pant
        mov Ancho_P,ax
        mov ax, ds:Ancho_Img
        mov Ancho_I,ax
        mov dx,@data
        push dx
        pop es
        mov ax, Ventana1
        mov ds, ax
        mov si, Pos_Y
        mov ax, Ancho_P
        mul si  
        mov si, ax
        add si, Pos_X
        mov di, Dest
        mov cx, Ancho_I
@@CopiaFila:
        push si
        push cx
        mov cx, Ancho_I
        cld
        rep movsb
        pop cx
        pop si
        add si, Ancho_P
        dec cx
        jnz @@CopiaFila
        ret
CargarBuffer ENDP

;############################################################################
; Procedimiento que toma un buffer y lo muestra en pantalla
;############################################################################
MostrarBuffer PROC NEAR USES ax cx si di ds es , Pos_X :WORD, Pos_Y:WORD, \
Dest :WORD
LOCAL Ancho_I:WORD, Ancho_P:WORD

        mov ax, ds:Ancho_Pant
        mov Ancho_P,ax
        mov ax, ds:Ancho_Img
        mov Ancho_I,ax

        mov ax, Ventana1
        mov es, ax
        mov di, Pos_Y
        mov ax, Ancho_P
        mul di
        mov di, ax
        add di, Pos_X
        mov si, Dest
        mov cx, Ancho_I
@@CopiaFila:
        push di
        push cx
        mov cx, Ancho_I
        cld
        rep movsb
        pop cx
        pop di
        add di, Ancho_P
        dec cx
        jnz @@CopiaFila
        ret
MostrarBuffer ENDP

;############################################################################
; Procedimiento que transforma un trozo de imagen de un buffer
;############################################################################
TransfBuffer PROC NEAR USES dx es ds si di ax bx cx

        mov dx, @data
        mov es, dx
        mov si, OFFSET ds:MatrizTrans
        mov di, OFFSET ds:Buffer_Destino
        mov cx, ds:Area
        cld
        xor bh,bh
@@HazPunto:
        lodsw
        mov bx,ax
        mov al,OFFSET ds:[Buffer_Fuente+bx]
        stosb
        dec cx
        jnz @@HazPunto
        ret
TransfBuffer ENDP

;###############################
;Procedimiento que pide los parametros
;###############################
Captura PROC NEAR USES bx cx dx , Cadena:WORD 
        mov ah,09h              ; Vamos a imprimir un mensage para
        mov dx,Cadena           ; indicar que parametro debemos introducir
        int 21h
        xor bx,bx               ; Aqui guardamos el valor del parametro
@bucle:
        mov ah, 01h
        int 21h                 ; En AL esta el caracter leido

        cmp al, 0Dh             ; Salir si se pulsa ENTER
        je @Fin

        sub al,30h              ; Le restamos el valor ASCII del caracter 0
        cbw                     ; Combertimos AL de BYTE a WORD
        mov cx,ax               ; Lo cambiamos de sitio
        mov ax,10               ; Base del sistema decimal
        mul bx                  ; Lo que habimos almacenado se multiplica
        add ax,cx               ; Le sumamos el nuevo caracter
        mov bx,ax               ; y lo situamos en BX para comenzar el bucle
        jmp @bucle
@Fin:
        mov ax,bx               ; El resultado se devuelve en AX
        ret
Captura ENDP
;##############################################
; Este procedimiento pide todos los parametros
; y calcula el resto
;##############################################
Param PROC USES ax bx dx
        mov dx, OFFSET ds:Ped_Radio        ;Vamos a pedir el radio
        push dx
        call Captura
        mov ds:R_Circulo, al               ;Ponemos el nuevo valor
        mov bx, 2                       ;Puesto que es necesario que el ancho
        add bx,ax                       ;sea algo superior , este sera el doble
        mov ax, 2                       ;del radio + 2
        mul bx
        mov ds:Ancho_Img, ax
        Cuadrado ds:Ancho_Img           ;Calculamos el area de la imagen a tomar 
        mov ds:Area,ax

        mov dx, OFFSET ds:Ped_Dist         ;Vamos a pedir la distancia al plano
        push dx
        call Captura
        mov ds:Dist_Plano, al
        ret

Param ENDP

;@@@@@@@@@@@@#############@@@@@@@@@@@|||||||||||||||||||||||||||||||||
Codigo PROC  
        mov dx,@DATA
        mov ds,dx

        call Param

        mov ax, ds:Ancho_img
        push ax
        call Crear_Matriz

        Modo13
        mov dx, OFFSET ds:NombreTGA
        push dx
        mov dx, OFFSET ds:BufferTGA
        push dx
        call CargaTGA

        mov ax,0
        int 33h
        mov ax,0007h
        mov cx,0
        mov dx,600
        int 33h
        mov ax,0008h
        mov cx,0
        mov dx,150
        int 33h
        mov ax,3
        int 33h
        mov ds:Pos_MX,cx
        mov ds:Pos_MY,dx

@Bucle_Prin:
        push ds:Pos_MX
        push ds:Pos_MY
        mov dx,OFFSET ds:Buffer_Fuente
        push dx
        call CargarBuffer

        call TransfBuffer

        push ds:Pos_MX
        push ds:Pos_MY
        mov dx,OFFSET ds:Buffer_Destino
        push dx
        call MostrarBuffer
@Movimiento:
        mov ax,3
        int 33h
        shr cx,1
        cmp ds:Pos_MX,cx
        jnz @SeMovio
        cmp ds:Pos_MY,dx
        jnz @SeMovio
        mov ah,6
        mov dl,0ffh
        int 21h
        jz @Movimiento
        jmp @Salir
@SeMovio:
        push dx
        push cx
        push ds:Pos_MX
        push ds:Pos_MY
        mov dx, OFFSET ds:Buffer_Fuente
        push dx
        call MostrarBuffer
        pop cx
        pop dx
        mov ds:Pos_MX,cx
        mov ds:Pos_MY,dx
        jmp @Bucle_Prin
@Salir:
        Salir
Codigo ENDP

        END Codigo
